﻿// Dll1.cpp : 定义 DLL 应用程序的导出函数。
//

#include "stdafx.h"


#include "Alg.h"

#ifdef  __cplusplus
extern "C" {
#endif
#include "api.h"
#include "rng.h"
#ifdef  __cplusplus
}
#endif

unsigned long longrand_get_sd_byts() {

	return 48;//bytes of init seed
}

int rand_init(unsigned char * s, unsigned long long s_byts) {

	randombytes_init(s, NULL, 256);
	return 0;
}

int rand_byts(unsigned long long r_byts, unsigned char * r) {

	randombytes(r, r_byts);
	return 0;
}



unsigned long long pke_get_pk_byts() {
	return CRYPTO_PUBLICKEYBYTES;
}

unsigned long long pke_get_sk_byts() {
	return CRYPTO_SECRETKEYBYTES;
}
unsigned long long pke_get_ct_byts() {
	return CRYPTO_CIPHERTEXTBYTES;
}

int pke_keygen(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts) {
	lacpke_keygen(pk, sk);
	*pk_byts = CRYPTO_PUBLICKEYBYTES;
	*sk_byts = CRYPTO_SECRETKEYBYTES;
	return 0;
}

int pke_enc(unsigned char * pk, unsigned long long pk_byts, unsigned char * m, unsigned long long m_byts, unsigned char * c, unsigned long long * c_byts) {
	lacpke_enc(c, c_byts, m, m_byts, pk);
	return 0;
}

int pke_dec(unsigned char * sk, unsigned long long sk_byts, unsigned char * c, unsigned long long c_byts, unsigned char * m, unsigned long long * m_byts) {
	lacpke_dec(m, m_byts, c, c_byts, sk);
	return 0;
}


unsigned long long kem_get_pk_byts() {
	return CRYPTO_PUBLICKEYBYTES;
}

unsigned long long kem_get_sk_byts() {
	return CRYPTO_SECRETKEYBYTES;
}

unsigned long long kem_get_ss_byts() {
	return CRYPTO_BYTES;
}

unsigned long long kem_get_ct_byts() {
	return CRYPTO_CIPHERTEXTBYTES;
}

int kem_keygen(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts) {
	*pk_byts = CRYPTO_PUBLICKEYBYTES;
	*sk_byts = CRYPTO_SECRETKEYBYTES;
	lackem_keygen(pk, sk);
	return 0;
}

int kem_enc(unsigned char * pk, unsigned long long pk_byts, unsigned char * ss, unsigned long long * ss_byts, unsigned char * ct, unsigned long long * ct_byts) {
	*ss_byts = CRYPTO_BYTES;
	*ct_byts = CRYPTO_CIPHERTEXTBYTES;
	lackem_enc(ct, ss, pk);
	return 0;
}

int kem_dec(unsigned char * sk, unsigned long long sk_byts, unsigned char * ct, unsigned long long ct_byts, unsigned char * ss, unsigned long long * ss_byts) {
	*ss_byts = CRYPTO_BYTES;
	lackem_dec(ss, ct, sk);
	return 0;
}


unsigned long long kex_get_rounds() {
	return 2;
}

unsigned long long kex_get_pk_byts() {
	return 0;
}

unsigned long long kex_get_sk_byts() {
	return 0;
}

unsigned long long kex_get_pa_byts() {
	return CRYPTO_SECRETKEYBYTES;
}

unsigned long long kex_get_pb_byts() {
	return 0;
}

unsigned long long kex_get_ss_byts() {
	return CRYPTO_BYTES;
}

unsigned long long kex_get_bw_byts() {
	return CRYPTO_CIPHERTEXTBYTES+CRYPTO_PUBLICKEYBYTES;
}

int kex_init_a(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts, unsigned char * pa, unsigned long long * pa_byts) {

	*pk_byts = 0;
	*sk_byts = 0;
	*pa_byts = 0;

	return 0;
}

int kex_init_b(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts, unsigned char * pb, unsigned long long * pb_byts) {
	
	*pk_byts = 0;
	*sk_byts = 0;
	*pb_byts = 0;
	return 0;
}

int kex_send_a(unsigned char * pkb, unsigned long long pkb_byts, unsigned char * pa, unsigned long long * pa_byts, unsigned char * ma, unsigned long long * ma_byts) {
	
	kex_alice_send(ma, pa);
	*ma_byts = CRYPTO_PUBLICKEYBYTES;
	*pa_byts = CRYPTO_SECRETKEYBYTES;
	return 0;
}

int kex_send_b(unsigned char * pka, unsigned long long pka_byts, unsigned char * ma, unsigned long long ma_byts, unsigned char * pb, unsigned long long * pb_byts, unsigned char * mb, unsigned long long * mb_byts, unsigned char * ss, unsigned long long * ss_byts) {
	
	kex_bob_receive(ma, mb, ss);
	*ss_byts = CRYPTO_BYTES;
	*mb_byts = CRYPTO_CIPHERTEXTBYTES;
	*pb_byts = 0;
	return 0;
}

int kex_resp_a(unsigned char * mb, unsigned long long mb_byts, unsigned char * pa, unsigned long long * pa_byts, unsigned char * ma, unsigned long long * ma_byts, unsigned char * ss, unsigned long long * ss_byts) {
	
	*ma_byts = 0;
	*ss_byts = CRYPTO_BYTES;
	kex_alice_receive(pa + DIM_N, pa, mb, ss);
	return 0;

}




