#pragma once

//pke
__declspec(dllexport) unsigned long long pke_get_pk_byts();
__declspec(dllexport) unsigned long long pke_get_sk_byts();
__declspec(dllexport) unsigned long long pke_get_ct_byts();
__declspec(dllexport) int pke_keygen(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts);
__declspec(dllexport) int pke_enc(unsigned char * pk, unsigned long long pk_byts, unsigned char * m, unsigned long long m_byts, unsigned char * c, unsigned long long * c_byts);
__declspec(dllexport) int pke_dec(unsigned char * sk, unsigned long long sk_byts, unsigned char * c, unsigned long long c_byts, unsigned char * m, unsigned long long * m_byts);


//kem
__declspec(dllexport) unsigned long long kem_get_pk_byts();
__declspec(dllexport) unsigned long long kem_get_sk_byts();
__declspec(dllexport) unsigned long long kem_get_ss_byts();
__declspec(dllexport) unsigned long long kem_get_ct_byts();
__declspec(dllexport) int kem_keygen(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts);
__declspec(dllexport) int kem_enc(unsigned char * pk, unsigned long long pk_byts, unsigned char * ss, unsigned long long * ss_byts, unsigned char * ct, unsigned long long * ct_byts);
__declspec(dllexport) int kem_dec(unsigned char * sk, unsigned long long sk_byts, unsigned char * ct, unsigned long long ct_byts, unsigned char * ss, unsigned long long * ss_byts);

//kex
__declspec(dllexport) unsigned long long kex_get_rounds();
__declspec(dllexport) unsigned long long kex_get_pk_byts();
__declspec(dllexport) unsigned long long kex_get_sk_byts();
__declspec(dllexport) unsigned long long kex_get_pa_byts();
__declspec(dllexport) unsigned long long kex_get_pb_byts();
__declspec(dllexport) unsigned long long kex_get_ss_byts();
__declspec(dllexport) unsigned long long kex_get_bw_byts();

__declspec(dllexport) int kex_init_a(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts, unsigned char * pa, unsigned long long * pa_byts);
__declspec(dllexport) int kex_init_b(unsigned char * pk, unsigned long long * pk_byts, unsigned char * sk, unsigned long long * sk_byts, unsigned char * pb, unsigned long long * pb_byts);
__declspec(dllexport) int kex_send_a(unsigned char * pkb, unsigned long long pkb_byts, unsigned char * pa, unsigned long long * pa_byts, unsigned char * ma, unsigned long long * ma_byts);
__declspec(dllexport) int kex_send_b(unsigned char * pka, unsigned long long pka_byts, unsigned char * ma, unsigned long long ma_byts, unsigned char * pb, unsigned long long * pb_byts, unsigned char * mb, unsigned long long * mb_byts, unsigned char * ss, unsigned long long * ss_byts);
__declspec(dllexport) int kex_resp_a(unsigned char * mb, unsigned long long mb_byts, unsigned char * pa, unsigned long long * pa_byts, unsigned char * ma, unsigned long long * ma_byts, unsigned char * ss, unsigned long long * ss_byts);


__declspec(dllexport) unsigned long longrand_get_sd_byts();
__declspec(dllexport) int rand_init(unsigned char * s, unsigned long long s_byts);
__declspec(dllexport) int rand_byts(unsigned long long r_byts, unsigned char * r);